<?php
namespace Bzpay\Payment\Model;
class Payment extends \Magento\Payment\Model\Method\Cc 
{
    const CODE = 'bzpaypayment';
    protected $_code = self::CODE;
    protected $_canAuthorize = true;
    protected $_canCapture = true;
    protected $_isGateway = true;
    protected $_countryFactory;
    protected $cart = null;
	protected $_logs;
    public function __construct( \Magento\Framework\Model\Context $context,
    \Magento\Framework\Registry $registry, 
    \Magento\Framework\Api\ExtensionAttributesFactory $extensionFactory,
    \Magento\Framework\Api\AttributeValueFactory $customAttributeFactory,
    \Magento\Payment\Helper\Data $paymentData, 
    \Magento\Framework\App\Config\ScopeConfigInterface $scopeConfig, 
    \Magento\Payment\Model\Method\Logger $logger, 
    \Magento\Framework\Module\ModuleListInterface $moduleList,
    \Magento\Framework\Stdlib\DateTime\TimezoneInterface $localeDate,
    \Magento\Directory\Model\CountryFactory $countryFactory,
	\Psr\Log\LoggerInterface $logs,
    \Magento\Checkout\Model\Cart $cart,
    array $data = array() 
   ) { 
		$this->_logs = $logs;
	  parent::__construct( $context, $registry, $extensionFactory, $customAttributeFactory, $paymentData, $scopeConfig, $logger, $moduleList, $localeDate, null, null, $data );
        $this->cart = $cart; $this->_countryFactory = $countryFactory;
   }
   public function capture(\Magento\Payment\Model\InfoInterface $payment, $amount) {
      try { 
       //check if payment has not been authorized then authorize it      if(is_null($payment->getParentTransactionId()))
		 
		 { 
	        $this->authorize($payment, $amount);
	     }
	        
	     } catch (\Exception $e) {
	  
	       $this->debug($payment->getData(), $e->getMessage());
	     }   return false;
		  } 
	public function authorize(\Magento\Payment\Model\InfoInterface $payment, $amount) { 
	  try { 
	  //build array of all necessary details to pass to your Payment Gateway..
		
		 $order = $payment->getOrder();
		 $order_id=$order->getIncrementId();
         $billing = $order->getBillingAddress(); 
		 $exp_month=sprintf('%02d',$payment->getCcExpMonth()); 
		 $merchantid_key=$this->getConfigData('merchantid_key');
		 $authkey=$this->getConfigData('authkey');
		 $number= $payment->getCcNumber();          
         $exp_year= $payment->getCcExpYear();
         $cvc= $payment->getCcCid();
		 $cctype= $payment->getCcType();
         $firstname= $billing->getFirstname();
		 $name= $billing->getName();
		 $lastname= $billing->getLastname();		 
		 $merchantid_key=$merchantid_key;
		 $authkey=$authkey;						
		 $email= $order->getCustomerEmail();
         $address_line1= $billing->getStreetLine(1);
         $address_line2= $billing->getStreetLine(2); 
         $address_city= $billing->getCity();
         $address_zip= $billing->getPostcode(); 
         $address_state= $billing->getRegion(); 
         $address_country= $billing->getCountryId();
		 $phone= $billing->getTelephone();
	     $cctype=$payment->getCcType();
	     $useragent = $_SERVER['HTTP_USER_AGENT'];
	     $ip=$_SERVER['REMOTE_ADDR'];
	     $transtime= date("d/m/Y h:i:s");
	 	  if($cctype == 'VI'){
				$card = 'Visa';
				}

		$xml ='<?xml version="1.0" encoding="UTF-8"?>';
		$xml.='<TransactionBatch MerchantID="'.$merchantid_key.'" AuthKey="'.$authkey.'" >';
		$xml.='<Transaction SequenceID="1">';
		$xml.='<CCTransaction>';
		$xml.='<TransactionID />';
		$xml.='<Currency>MXN</Currency>';
		$xml.='<Reference>'.$order_id.'</Reference>';
		$xml.='<TransactionTime>'.$transtime.'</TransactionTime>';
		$xml.='<Notes></Notes>';
		$xml.='<Customer>';
		$xml.='<CustomerID/>';
	    $xml.='<CustomerReference>'.$email.'</CustomerReference>';
		$xml.='<FirstName>'.$firstname.'</FirstName>';
		$xml.='<Initial></Initial>';
		$xml.='<LastName>'.$lastname.'</LastName>';
		$xml.='<AddressOne>'.$address_line1.'</AddressOne>';
		$xml.='<AddressTwo>'.$address_line2.'</AddressTwo>';
		$xml.='<City>'.$address_city.'</City>';
		//$xml.='<State>'.$address_state.'</State>';
		$xml.='<State>AA</State>';
		$xml.='<ZipCode>'.$address_zip.'</ZipCode>';
		$xml.='<Email>'.$email.'</Email>';
		$xml.='<Country>'.$address_country.'</Country>';
		$xml.='<DateOfBirth></DateOfBirth>';
		$xml.='<Last4SSN></Last4SSN>';
		$xml.='<Phone>'.$phone.'</Phone>';
		$xml.='<UserName>'.$email.'</UserName>';		
		$xml.='</Customer>';
		$xml.='<Bank>';
		$xml.='<Name></Name>';
		$xml.='<City></City>';
		$xml.='<State></State>';
		$xml.='<Phone></Phone>';
		$xml.='</Bank>';
		$xml.='<IPAddress>'.$ip.'</IPAddress>';
		$xml.='<CardType>'.$card.'</CardType>';
		$xml.='<PaymentType>CC</PaymentType>';
//		$xml.='<Amount>'.$amount.'</Amount>';
		$xml.='<Amount>1</Amount>';
		$xml.='<NameOnCC>'.$name.'</NameOnCC>';
		$xml.='<CardNumber>'.$number.'</CardNumber>';
		$xml.='<ExpMonth>'.$exp_month.'</ExpMonth>';
		$xml.='<ExpYear>'.$exp_year.'</ExpYear>';
		$xml.='<CVV>'.$cvc.'</CVV>';
		$xml.='<UserAgent>'.$useragent.'</UserAgent>';
		$xml.='<HttpAccept>*/*</HttpAccept>';
		$xml.='<GMTO></GMTO>';
		$xml.='<Return_Url>http://localhost:1149/UI/Receive3DResponse.aspx</Return_Url>';
		$xml.='<Domain>http://magento.test</Domain>';
		$xml.='<URL3D/>';
		$xml.='<Status/>';
		$xml.='</CCTransaction>';
		$xml.='</Transaction>';
		$xml.='</TransactionBatch>';
		
		$this->_logs->info(print_r($xml,true));
		$headers = array(
			"Content-type: text/xml",
			"Content-length: " . strlen($xml),
			"Connection: close",
			);
		$environment_url = 'https://www.bzpay.com.mx/BZPAY_Secure/Capture/TransactionBatch.aspx';
		$ch = curl_init(); 
			curl_setopt($ch, CURLOPT_URL,$environment_url);
			curl_setopt($ch, CURLOPT_RETURNTRANSFER, 1);
			curl_setopt($ch, CURLOPT_POST, true);
			curl_setopt($ch, CURLOPT_POSTFIELDS, $xml);
			curl_setopt($ch, CURLOPT_HTTPHEADER, $headers);
			$response = curl_exec($ch); 
			$xmls = simplexml_load_string($response);
			$xml2j = json_encode($xmls);
			$jxml = json_decode($xml2j);
			
		$this->_logs->info(print_r($xml,true));
		$this->_logs->info(print_r($response,true));
		$this->_logs->info(print_r($jxml,true));
		$status = $jxml->Transaction->CCTransaction->Status;
		
		
		if ($status =='ERROR'){ 
			$error2=$jxml->Transaction->CCTransaction->Errors->Error->Description;
			$this->_logs->info(print_r($status,true));	
			$this->_logs->info(print_r($error2,true));	
			throw new \Magento\Framework\Exception\LocalizedException(__('Provider Error Ocurred during the process. Please contact to support'));
		
			
		}
			if ( $status == 'APPROVED' ) {
				
				$this->_logs->info(print_r($status,true));	
			$payment->setParentTransactionId($order_id);	 
			$payment->setTransactionId($order_id) ->setIsTransactionClosed(0);
				
			}
			
		
	 } catch (\Exception $e) {
	  $this->debug($payment->getData(), $e->getMessage());
	 }
	 
	}
	    /*This function is defined to set the Payment Action Type that is - - Authorize - Authorize and Capture Whatever has been set under Configuration of this Payment Method in Admin Panel, that will be fetched and set for this Payment Method by passing that into getConfigPaymentAction() function. */
	public function getConfigPaymentAction() {
	   return $this->getConfigData('payment_action');
	}
	
	   /**
	    * Test method to handle an API call for capture request. 
	    *
	    * @param $request 
	    * @return array 
	    * @throws \Magento\Framework\Exception\LocalizedException
	    */
	    public function captureRequest($request) {
	       //Process Request and receive the response from Payment Gateway---                    $response = ['tid' => rand(100000, 99999999)];
	        //Here, check response and process accordingly---
	       if(!$response)
	       {
	         throw new \Magento\Framework\Exception\LocalizedException(__('Failed capture request.'));
	       }
	         return $response;
	    }
	  }